<?php 

if (!defined('FORUM')) die();


if (isset($_POST['create_dump']))
{
	$table_name = $_POST['table_name'];
	$query = array(
		'SELECT'	=> '*',
		'FROM'		=> $table_name,
	);
	
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$output = array();
	while ($rows = $forum_db->fetch_assoc($result))
		$output[] = $rows;
	
	if (!function_exists('write_cache_file'))
		require FORUM_ROOT.'include/cache.php';
	
	$file_name = date('Ymd_His').'_pan_uploader.php';
	// Output config as PHP code
	if (!write_cache_file(FORUM_ROOT.$forum_url['pan_converter_ext_dumps'].$file_name, '<?php'."\n\n".'$pan_uploader = '.var_export($output, true).';'."\n\n".'?>'))
	{
		error('Unable to write configuration cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
	}
	
	$forum_flash->add_info('All strings are converted!');
	redirect(forum_link($forum_url['pan_converter_ext_section'], $section), '');
}


if (isset($_POST['restore_table']))
{
	$file_path = $_POST['file_path'];
	if (file_exists($file_path))
		include $file_path;
	
	if (!defined('FORUM_XML_FUNCTIONS_LOADED'))
		require FORUM_ROOT.'include/xml.php';
	
	$manifest = is_readable(FORUM_ROOT.'extensions/pan_uploader/manifest.xml') ? file_get_contents(FORUM_ROOT.'extensions/pan_uploader/manifest.xml') : false;
	$ext_data = xml_to_array($manifest);
	
	if (isset($ext_data['extension']['version']) && $ext_data['extension']['version'] < 0.5)
	{
		if ($forum_db->table_exists('uploaded_files'))
		{
			//DELETE ALL FIELDS
			$query = array(
				'DELETE'	=> 'uploaded_files',
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			
			$str_count = 0;
			foreach ($pan_uploader as $key => $string)
			{
				$values = array();
				
				if (!empty($string['id'])) $values['id'] = "'".$string['id']."'";
				if (!empty($string['base_name'])) $values['base_name'] = "'".$forum_db->escape($string['base_name'])."'";
				if (!empty($string['user_id'])) $values['user_id'] = "'".$string['user_id']."'";
				if (!empty($string['user_name'])) $values['user_name'] = "'".$forum_db->escape($string['user_name'])."'";
				if (!empty($string['user_ip'])) $values['user_ip'] = "'".$forum_db->escape($string['user_ip'])."'";
				if (!empty($string['file_url'])) $values['file_url'] = "'".$forum_db->escape($string['file_url'])."'";
				if (!empty($string['file_loaded'])) $values['file_loaded'] = "'".$string['file_loaded']."'";
				if (!empty($string['file_type'])) $values['file_type'] = "'".$forum_db->escape($string['file_type'])."'";
				if (!empty($string['file_ext'])) $values['file_ext'] = "'".$forum_db->escape($string['file_ext'])."'";
				if (!empty($string['file_size'])) $values['file_size'] = "'".$string['file_size']."'";
				if (!empty($string['downloads'])) $values['downloads'] = "'".$string['downloads']."'";
				if (!empty($string['topic_id'])) $values['topic_id'] = "'".$string['topic_id']."'";
				if (!empty($string['post_id'])) $values['post_id'] = "'".$string['post_id']."'";
				
				//ADD NEW DATA
				$query = array(
					'INSERT'	=> ''.implode(', ', array_keys($values)).'',
					'INTO'		=> 'uploaded_files',
					'VALUES'	=> ''.implode(', ', array_values($values)).'',
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
				
				$str_count++;
			}
		}
		else
		{
			message('The extension Pan Uploader is not installed! First install the extension Pan Uploader.');
		}
	}
	else if (isset($ext_data['extension']['version']) && $ext_data['extension']['version'] >= 0.5)
	{
		if ($forum_db->table_exists('pan_uploader'))
		{
			//DELETE ALL FIELDS
			$query = array(
				'DELETE'	=> 'pan_uploader',
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			
			$str_count = 0;
			foreach ($pan_uploader as $key => $string)
			{
				$values = array();
				
				if (!empty($string['id'])) $values['id'] = "'".$string['id']."'";
				
				if (isset($string['real_name'])) {
					if (!empty($string['real_name']))
						$values['real_name'] = "'".$forum_db->escape($string['real_name'])."'";
					else
						$values['real_name'] = "'".$forum_db->escape($string['base_name'])."'";
				} else {
					$values['real_name'] = "'".$forum_db->escape($string['base_name'])."'";
				}
				
				if (isset($string['base_name'])) {
					if (!empty($string['base_name']))
						$values['base_name'] = "'".$forum_db->escape($string['base_name'])."'";
					else
						$values['base_name'] = "'".$forum_db->escape($string['real_name'])."'";
				}
				
				if (!empty($string['user_id'])) $values['user_id'] = "'".$string['user_id']."'";
				if (!empty($string['user_name'])) $values['user_name'] = "'".$forum_db->escape($string['user_name'])."'";
				if (!empty($string['user_ip'])) $values['user_ip'] = "'".$forum_db->escape($string['user_ip'])."'";
				if (!empty($string['file_url'])) $values['file_url'] = "'".$forum_db->escape($string['file_url'])."'";
				if (!empty($string['file_loaded'])) $values['file_loaded'] = "'".$string['file_loaded']."'";
				if (!empty($string['file_type'])) $values['file_type'] = "'".$forum_db->escape($string['file_type'])."'";
				if (!empty($string['file_ext'])) $values['file_ext'] = "'".$forum_db->escape($string['file_ext'])."'";
				if (!empty($string['file_size'])) $values['file_size'] = "'".$string['file_size']."'";
				if (!empty($string['downloads'])) $values['downloads'] = "'".$string['downloads']."'";
				if (!empty($string['topic_id'])) $values['topic_id'] = "'".$string['topic_id']."'";
				if (!empty($string['post_id'])) $values['post_id'] = "'".$string['post_id']."'";
				
				//ADD NEW DATA
				$query = array(
					'INSERT'	=> ''.implode(', ', array_keys($values)).'',
					'INTO'		=> 'pan_uploader',
					'VALUES'	=> ''.implode(', ', array_values($values)).'',
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
				
				$str_count++;
			}
			
		}
		else
		{
			message('The extension Pan Uploader is not installed! First install the extension Pan Uploader.');
		}
	}
	
	$forum_flash->add_info('Restored '.$str_count.' files');
	redirect(forum_link($forum_url['pan_converter_ext_section'], $section), '');
}

if (isset($_POST['delete_table']))
{
	$file_path = $_POST['file_path'];
	if (file_exists($file_path))
		unlink($file_path);
	
	$forum_flash->add_info('Dump file deleted.');
	redirect(forum_link($forum_url['pan_converter_ext_section'], $section), '');
}

$errors = array();

$module_name = ucwords(str_replace('_', ' ', $section));
$module_name = str_replace(' ', '', $module_name);

$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	array('Converter', forum_link($forum_url['pan_converter_ext'])),
	$module_name
);

define('FORUM_PAGE_SECTION', 'pan-converter-ext');
define('FORUM_PAGE', 'admin-pan-converter-ext-'.$section);
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>
	<div class="main-content main-frm">

		<div class="content-head">
			<h2 class="hn"><span>Create dump for Pan Uploader</span></h2>
		</div>

<?php

// If there were any errors, show them
if (!empty($errors))
{
		$forum_page['errors'] = array();
		foreach ($errors as $cur_error)
			$forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
			
?>
		<div class="ct-box error-box">
			<h2 class="warn hn">Errors!</h2>
			<ul class="error-list">
				<?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
			</ul>
		</div>
<?php
}


if ($forum_db->table_exists('uploaded_files'))
{
	$pan_images = array();
	$pan_files = array();
	$query = array(
		'SELECT'	=> 'id, file_type',
		'FROM'		=> 'uploaded_files',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	while ($rows = $forum_db->fetch_assoc($result))
	{
		if ($rows['file_type'] == 'image')
			$pan_images[] = $rows;
		else if ($rows['file_type'] == 'file')
			$pan_files[] = $rows;
	}

?>

		<div class="frm-form">
			<div class="ct-box">
				<p><strong>Notice!</strong></p>
				<p>Total Images: <?php echo count($pan_images) ?></p>
				<p>Total Files: <?php echo count($pan_files) ?></p>
			</div>
		</div>

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_converter_ext_section'], $section) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_ext_section'], $section)) ?>" />
				<input type="hidden" name="table_name" value="uploaded_files" />
			</div>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="create_dump" value="Create dump" /></span>
			</div>
		</form>

<?php
}
else if ($forum_db->table_exists('pan_uploader'))
{
	$pan_images = array();
	$pan_files = array();
	$query = array(
		'SELECT'	=> 'id, file_type',
		'FROM'		=> 'pan_uploader',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	while ($rows = $forum_db->fetch_assoc($result))
	{
		if ($rows['file_type'] == 'image')
			$pan_images[] = $rows;
		else if ($rows['file_type'] == 'file')
			$pan_files[] = $rows;
	}

?>

		<div class="frm-form">
			<div class="ct-box">
				<p><strong>Notice!</strong></p>
				<p>Total Images: <?php echo count($pan_images) ?></p>
				<p>Total Files: <?php echo count($pan_files) ?></p>
			</div>
		</div>

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_converter_ext_section'], $section) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_ext_section'], $section)) ?>" />
				<input type="hidden" name="table_name" value="pan_uploader" />
			</div>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="create_dump" value="Create dump" /></span>
			</div>
		</form>

<?php
} else {
?>
		<div class="frm-form">
			<div class="ct-box">
				<p><strong><?php echo 'Pan Uploader not installed or not enabled!'; ?></strong></p>
			</div>
		</div>
<?php
}
?>

		<div class="ct-group">
			
			<table>
				<thead>
					<tr>
						<th class="tc2" style="width:30%;">Name</th>
						<th class="tc2" style="width:10%;">Images</th>
						<th class="tc2" style="width:10%;">Files</th>
						<th class="tc3" style="width:10%;">Restore</th>
						<th class="tc4" style="width:10%;">Delete</th>
						
					</tr>
				</thead>
			<tbody>
				
<?php 
	foreach (scandir(FORUM_ROOT.$forum_url['pan_converter_ext_dumps']) as $file_part)
	{
		if (strpos($file_part, 'uploader.php'))
		{
			if (file_exists(FORUM_ROOT.$forum_url['pan_converter_ext_dumps'].$file_part))
				include FORUM_ROOT.$forum_url['pan_converter_ext_dumps'].$file_part;
			
			if (isset($pan_uploader))
			{
				$num_images = 0;
				$num_files = 0;
				foreach ($pan_uploader as $key => $val)
				{
					if ($val['file_type'] == 'image')
						$num_images++;
					else if ($val['file_type'] == 'file')
						$num_files++;
				}
			}
?>
		<form action="<?php echo forum_link($forum_url['pan_converter_ext_section'], $section) ?>" accept-charset="utf-8" method="post" class="frm-form">
				<tr>
					<input type="hidden" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_ext_section'], $section)) ?>" name="csrf_token" />
					<input type="hidden" name="file_path" value="<?php echo FORUM_ROOT.$forum_url['pan_converter_ext_dumps'].$file_part ?>" />
					
					<td class="tc2"><?php echo $file_part ?></td>
					<td class="tc2"><?php echo $num_images ?></td>
					<td class="tc2"><?php echo $num_files ?></td>
					
					<td class="tc3"><input type="submit" name="restore_table" value="Restore" /></td>
					<td class="tc4"><input type="submit" name="delete_table" value="Delete" /></td>
				</tr>
		</form>
<?php
		}
	}
?>
				</tbody>
			</table>
			
		</div>

	</div>

<?php


$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

